class DBMclient:
    def __init__(self, server_host, server_port):
        self.server = server_host
        self.port = server_port
        self.sock = self.connect()
        self.status = None
        self.args = None

    def connect(self):
        sock = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
        address = (self.server, self.port)
        sock.connect(address)
        print "Connected to Server: " + self.server
        return sock

    def close(self):
        self.sock.close()

    def send(self, request):
        # request is one of: KEYS, SIZE, RECORD, QUERY, FILTERS, ... (read the specification)
        # use the send_size function to send a request and recv_size function to get the request
        # (and do the same thing in the server side too!)
        print "request =>", message         # Good for debug
        send_size(self.sock, request)
        self.status = recv_size(self.sock)  # status line (like: "401 Invalid record number")
        print self.status
        # check if self.status is None ... and print error ...
        # split request to arguments
        # Now you have to dispatch to one of the following methods:
        #      self.handle_SIZE()
        #      self.handle_KEYS()
        #      self.handle_RECORD()
        #      self.handle_FILTERS()
        #      self.handle_QUERY()
        #      self.handle_QUIT()
        # don't forget an invalid request !
        return self.status

    def handle_SIZE(self):
        # database size should arrive from DBMserver
        pass

    def handle_KEYS(self):
        # database keys (columns) should arrive from DBMserver
        pass

    def handle_RECORD(self):
        # record should arrive (you may get one csv line and do the formatting here)
        pass

    def handle_FILTERS(self):
        # You need to send filters file to DBM server
        pass

    def handle_QUERY(self):
        # database query
        pass

    def handle_QUIT(self):
        # quit and close connection
        pass

#-------------------------------

# A formatted record printing (key=value per line  format)
def print_record(record, keys):
    for key in keys:
        print "    %-16s = %s" %  (key, record[key])
