from db_manager import *
from dbm_client import *

def test1():
    file = "table1.csv"
    dbm = DataBaseManager(file)
    print "KEYS =", dbm.keys
    rec = dbm.record(17)
    print "RECORD 17:"
    print_record(rec, dbm.keys)

    rec = dbm.record(47)
    print "RECORD 47:"
    print_record(rec, dbm.keys[0:5])

def test2():
    file = "table1.csv"
    dbm = DataBaseManager(file)
    print "KEYS ="
    i=0
    for key in dbm.keys:
        print i, key
        i += 1


def filter1(record):
    if record['City'] == 'San Francisco' and record['BloodType'] == 'A+':
        return record
    else:
        return None

def test3():
    file = "table2.csv"
    dbm = DataBaseManager(file)
    records = dbm.select(filter1)
    print "Number persons:", len(records)
    print "RECORD 0:"
    print_record(records[0], dbm.keys[0:8])
    print "RECORD 7:"
    print_record(records[7], dbm.keys[0:8])
    print "RECORD 12:"
    print_record(records[12], dbm.keys[0:8])

def test4():
    file1 = "table1.csv"
    file2 = "table2.csv"

    # Starting two DataBaseManager objects !
    dbm1 = DataBaseManager(file1)
    dbm2 = DataBaseManager(file2)

    rec = dbm1.record(17)
    print "DBM1 RECORD 17:"
    print_record(rec, dbm1.keys)

    rec = dbm2.record(17)
    print "DBM2 RECORD 17:"
    print_record(rec, ["Surname", "City", "ZipCode"] )


#######################################################################################

if __name__ == "__main__":
    test3()

